## paho.mqtt.c 1.3.12

=== CMakeLists.txt ===
#*******************************************************************************
#  Copyright (c) 2015, 2020 logi.cals GmbH and others
#
#  All rights reserved. This program and the accompanying materials
#  are made available under the terms of the Eclipse Public License v2.0
#  and Eclipse Distribution License v1.0 which accompany this distribution.
#
#  The Eclipse Public License is available at
#     https://www.eclipse.org/legal/epl-2.0/
#  and the Eclipse Distribution License is available at
#    http://www.eclipse.org/org/documents/edl-v10.php.
#
#  Contributors:
#     Rainer Poisel - initial version
#     Genis Riera Perez - Add support for building debian package
#*******************************************************************************/

# Note: on OS X you should install XCode and the associated command-line tools

CMAKE_MINIMUM_REQUIRED(VERSION 2.8.12)
PROJECT("Eclipse Paho C" C)
MESSAGE(STATUS "CMake version: " ${CMAKE_VERSION})
MESSAGE(STATUS "CMake system name: " ${CMAKE_SYSTEM_NAME})

SET(CMAKE_SCRIPTS "${CMAKE_SOURCE_DIR}/cmake")
SET(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/modules")

## build settings
file(READ version.major PAHO_VERSION_MAJOR)
file(READ version.minor PAHO_VERSION_MINOR)
file(READ version.patch PAHO_VERSION_PATCH)
SET(CLIENT_VERSION ${PAHO_VERSION_MAJOR}.${PAHO_VERSION_MINOR}.${PAHO_VERSION_PATCH})

INCLUDE(GNUInstallDirs)

STRING(TIMESTAMP BUILD_TIMESTAMP UTC)
MESSAGE(STATUS "Timestamp is ${BUILD_TIMESTAMP}")

IF(WIN32)
  ADD_DEFINITIONS(-D_CRT_SECURE_NO_DEPRECATE -DWIN32_LEAN_AND_MEAN)
ELSEIF(${CMAKE_SYSTEM_NAME} STREQUAL "Darwin")
  ADD_DEFINITIONS(-DOSX)
ENDIF()

## build options
SET(PAHO_WITH_SSL FALSE CACHE BOOL "Flag that defines whether to build ssl-enabled binaries too. ")
SET(PAHO_BUILD_SHARED TRUE CACHE BOOL "Build shared library")
SET(PAHO_BUILD_STATIC FALSE CACHE BOOL "Build static library")
SET(PAHO_BUILD_DOCUMENTATION FALSE CACHE BOOL "Create and install the HTML based API documentation (requires Doxygen)")
SET(PAHO_BUILD_SAMPLES FALSE CACHE BOOL "Build sample programs")
SET(PAHO_BUILD_DEB_PACKAGE FALSE CACHE BOOL "Build debian package")
SET(PAHO_ENABLE_TESTING TRUE CACHE BOOL "Build tests and run")
SET(PAHO_ENABLE_CPACK TRUE CACHE BOOL "Enable CPack")
SET(PAHO_HIGH_PERFORMANCE FALSE CACHE BOOL "Disable tracing and heap tracking")
SET(PAHO_USE_SELECT FALSE CACHE BOOL "Revert to select system call instead of poll")

IF (PAHO_HIGH_PERFORMANCE)
  ADD_DEFINITIONS(-DHIGH_PERFORMANCE=1)
ENDIF()

IF (PAHO_USE_SELECT)
  ADD_DEFINITIONS(-DUSE_SELECT=1)
ENDIF()

IF (NOT PAHO_BUILD_SHARED AND NOT PAHO_BUILD_STATIC)
    MESSAGE(FATAL_ERROR "You must set either PAHO_BUILD_SHARED, PAHO_BUILD_STATIC, or both")
ENDIF()

IF(PAHO_BUILD_DEB_PACKAGE)
    set(CMAKE_INSTALL_DOCDIR share/doc/libpaho-mqtt)
    set(CPACK_DEBIAN_PACKAGE_GENERATE_SHLIBS ON)
    set(CPACK_DEBIAN_PACKAGE_GENERATE_SHLIBS_POLICY ">=")
ENDIF()

ADD_SUBDIRECTORY(src)
IF(PAHO_BUILD_SAMPLES)
    ADD_SUBDIRECTORY(src/samples)
ENDIF()

IF(PAHO_BUILD_DOCUMENTATION)
    ADD_SUBDIRECTORY(doc)
ENDIF()

IF (PAHO_ENABLE_CPACK)
    ### packaging settings
    FILE(GLOB samples "src/samples/*.c")
    INSTALL(FILES ${samples} DESTINATION ${CMAKE_INSTALL_DOCDIR}/samples)

    SET(CPACK_PACKAGE_VENDOR "Eclipse Paho")
    SET(CPACK_PACKAGE_NAME "Eclipse-Paho-MQTT-C")
    INSTALL(FILES CONTRIBUTING.md epl-v20 edl-v10 README.md notice.html DESTINATION ${CMAKE_INSTALL_DOCDIR})

    IF (WIN32)
        SET(CPACK_GENERATOR "ZIP")
    ELSEIF(PAHO_BUILD_DEB_PACKAGE)
        INSTALL(FILES CONTRIBUTING.md epl-v20 edl-v10 README.md notice.html DESTINATION ${CMAKE_INSTALL_DOCDIR})

        SET(CPACK_GENERATOR "DEB")
        CONFIGURE_FILE(${CMAKE_SCRIPTS}/CPackDebConfig.cmake.in
                ${CMAKE_BINARY_DIR}/CPackDebConfig.cmake @ONLY)
        SET(CPACK_PROJECT_CONFIG_FILE ${CMAKE_BINARY_DIR}/CPackDebConfig.cmake)
    ELSE()
            SET(CPACK_GENERATOR "TGZ")
    ENDIF()
ELSE()
       FILE(GLOB samples "src/samples/*.c")
       INSTALL(FILES ${samples} DESTINATION ${CMAKE_INSTALL_DOCDIR})
ENDIF()

SET(CPACK_PACKAGE_VERSION_MAJOR ${PAHO_VERSION_MAJOR})
SET(CPACK_PACKAGE_VERSION_MINOR ${PAHO_VERSION_MINOR})
SET(CPACK_PACKAGE_VERSION_PATCH ${PAHO_VERSION_PATCH})
INCLUDE(CPack)

IF(PAHO_ENABLE_TESTING)
    ENABLE_TESTING()
    INCLUDE_DIRECTORIES(test src)
    ADD_SUBDIRECTORY(test)
ELSE()
    INCLUDE_DIRECTORIES(src)
ENDIF()

=== dist/Makefile ===
VERSION=1.3.0

check:
	rpmlint -i dist/paho-c.spec

rpm-prep:
	mkdir -p ${HOME}/rpmbuild/SOURCES/
	tar --transform="s/\./paho-c-${VERSION}/" -cf ${HOME}/rpmbuild/SOURCES/v${VERSION}.tar.gz --exclude=./build.paho --exclude=.git --exclude=*.bz ./ --gzip

rpm: rpm-prep
	rpmbuild -ba dist/paho-c.spec

=== src/CMakeLists.txt ===
#*******************************************************************************
#  Copyright (c) 2015, 2020 logi.cals GmbH and others
#
#  All rights reserved. This program and the accompanying materials
#  are made available under the terms of the Eclipse Public License v2.0
#  and Eclipse Distribution License v1.0 which accompany this distribution.
#
#  The Eclipse Public License is available at
#     https://www.eclipse.org/legal/epl-2.0/
#  and the Eclipse Distribution License is available at
#    http://www.eclipse.org/org/documents/edl-v10.php.
#
#  Contributors:
#     Rainer Poisel - initial version
#     Ian Craggs (IBM Corp.) - merge master
#     Ian Craggs - update for MQTTV5 support
#*******************************************************************************/

# Note: on OS X you should install XCode and the associated command-line tools

## compilation/linkage settings

CONFIGURE_FILE(VersionInfo.h.in
    ${CMAKE_BINARY_DIR}/VersionInfo.h
    @ONLY
    )

SET(common_src
  MQTTTime.c
  MQTTProtocolClient.c
  Clients.c
  utf-8.c
  MQTTPacket.c
  MQTTPacketOut.c
  Messages.c
  Tree.c
  Socket.c
  Log.c
  MQTTPersistence.c
  Thread.c
  MQTTProtocolOut.c
  MQTTPersistenceDefault.c
  SocketBuffer.c
  LinkedList.c
  MQTTProperties.c
  MQTTReasonCodes.c
  Base64.c
  SHA1.c
  WebSocket.c
  Proxy.c
)

IF (NOT PAHO_HIGH_PERFORMANCE)
  SET(common_src ${common_src}
    StackTrace.c
    Heap.c
    )
ENDIF()

IF (WIN32)
    SET(LIBS_SYSTEM ws2_32 crypt32 RpcRT4)
ELSEIF (UNIX)
    IF(CMAKE_SYSTEM_NAME MATCHES "Linux")
        SET(LIBS_SYSTEM c dl pthread rt)
        # anl is only available with glibc so check if it is found before using
        # it or build will fail on uclibc or musl
        FIND_LIBRARY(LIB_ANL anl)
        IF(LIB_ANL)
            SET(LIBS_SYSTEM "${LIBS_SYSTEM}" anl)
        ENDIF()
        ADD_DEFINITIONS(-D_GNU_SOURCE -fvisibility=hidden)
    ELSEIF (CMAKE_SYSTEM_NAME MATCHES "Android")
        SET(LIBS_SYSTEM c dl)
    ELSEIF (CMAKE_SYSTEM_NAME MATCHES "FreeBSD")
        SET(LIBS_SYSTEM compat pthread)
    ELSE()
        SET(LIBS_SYSTEM c pthread)
    ENDIF()
ENDIF()

IF (PAHO_BUILD_SHARED)
# common compilation for libpaho-mqtt3c and libpaho-mqtt3a
ADD_LIBRARY(common_obj OBJECT ${common_src})
SET_TARGET_PROPERTIES(common_obj PROPERTIES
    POSITION_INDEPENDENT_CODE ON
    COMPILE_DEFINITIONS "PAHO_MQTT_EXPORTS=1")
ADD_EXECUTABLE(MQTTVersion MQTTVersion.c)
SET_TARGET_PROPERTIES(MQTTVersion PROPERTIES
    POSITION_INDEPENDENT_CODE ON
    COMPILE_DEFINITIONS "PAHO_MQTT_IMPORTS=1")
ENDIF()

IF (PAHO_BUILD_STATIC)    
ADD_LIBRARY(common_obj_static OBJECT ${common_src})
SET_TARGET_PROPERTIES(common_obj_static PROPERTIES
    POSITION_INDEPENDENT_CODE ON
    COMPILE_DEFINITIONS "PAHO_MQTT_STATIC=1")
ENDIF()

IF (PAHO_BUILD_SHARED)
    ADD_LIBRARY(paho-mqtt3c SHARED $<TARGET_OBJECTS:common_obj> MQTTClient.c)
    ADD_LIBRARY(paho-mqtt3a SHARED $<TARGET_OBJECTS:common_obj> MQTTAsync.c MQTTAsyncUtils.c)
    
    TARGET_LINK_LIBRARIES(paho-mqtt3c ${LIBS_SYSTEM})
    TARGET_LINK_LIBRARIES(paho-mqtt3a ${LIBS_SYSTEM})
    TARGET_LINK_LIBRARIES(MQTTVersion paho-mqtt3a paho-mqtt3c ${LIBS_SYSTEM})
    
    SET_TARGET_PROPERTIES(
        paho-mqtt3c paho-mqtt3a PROPERTIES
        VERSION ${CLIENT_VERSION}
        SOVERSION ${PAHO_VERSION_MAJOR}
        COMPILE_DEFINITIONS "PAHO_MQTT_EXPORTS=1")

    IF(${CMAKE_SYSTEM_NAME} STREQUAL "Darwin")
		SET(MQTTCLIENT_ENTRY_POINT _MQTTClient_init)
		SET(MQTTASYNC_ENTRY_POINT _MQTTAsync_init)
	ELSEIF (NOT WIN32)
		SET(MQTTCLIENT_ENTRY_POINT MQTTClient_init)
		SET(MQTTASYNC_ENTRY_POINT MQTTAsync_init)
	ENDIF()

    IF (NOT WIN32)
        SET_TARGET_PROPERTIES(
            paho-mqtt3c PROPERTIES
            LINK_FLAGS "-Wl,-init,${MQTTCLIENT_ENTRY_POINT}")
        SET_TARGET_PROPERTIES(
            paho-mqtt3a PROPERTIES
            LINK_FLAGS "-Wl,-init,${MQTTASYNC_ENTRY_POINT}")
    ENDIF()

    FOREACH(TARGET paho-mqtt3c paho-mqtt3a)
        TARGET_INCLUDE_DIRECTORIES(${TARGET}
            PUBLIC
                $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
                $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
            PRIVATE
                ${CMAKE_BINARY_DIR})
    ENDFOREACH()
    
	INSTALL(TARGETS paho-mqtt3c paho-mqtt3a
		EXPORT eclipse-paho-mqtt-cTargets
		ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
		LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
		RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
    INSTALL(TARGETS MQTTVersion
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
ENDIF()

IF (PAHO_BUILD_STATIC)
    ADD_LIBRARY(paho-mqtt3c-static STATIC $<TARGET_OBJECTS:common_obj_static> MQTTClient.c)
    ADD_LIBRARY(paho-mqtt3a-static STATIC $<TARGET_OBJECTS:common_obj_static> MQTTAsync.c MQTTAsyncUtils.c)

    TARGET_LINK_LIBRARIES(paho-mqtt3c-static ${LIBS_SYSTEM})
    TARGET_LINK_LIBRARIES(paho-mqtt3a-static ${LIBS_SYSTEM})
    IF (NOT WIN32)
        SET_TARGET_PROPERTIES(paho-mqtt3c-static PROPERTIES OUTPUT_NAME paho-mqtt3c)
        SET_TARGET_PROPERTIES(paho-mqtt3a-static PROPERTIES OUTPUT_NAME paho-mqtt3a)
    ENDIF()       
    SET_TARGET_PROPERTIES(
        paho-mqtt3c-static paho-mqtt3a-static PROPERTIES
        VERSION ${CLIENT_VERSION}
        SOVERSION ${PAHO_VERSION_MAJOR}
        COMPILE_DEFINITIONS "PAHO_MQTT_STATIC=1")

    FOREACH(TARGET paho-mqtt3c-static paho-mqtt3a-static)
        TARGET_INCLUDE_DIRECTORIES(${TARGET}
            PUBLIC
                $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
                $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
            PRIVATE
                ${CMAKE_BINARY_DIR})
    ENDFOREACH()

    IF (NOT PAHO_BUILD_SHARED)
        INSTALL(TARGETS paho-mqtt3c-static paho-mqtt3a-static
            EXPORT eclipse-paho-mqtt-cTargets
            ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
            LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
            RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
    ELSE()
        INSTALL(TARGETS paho-mqtt3c-static paho-mqtt3a-static
            ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})
    ENDIF()
ENDIF()

INSTALL(FILES MQTTAsync.h MQTTClient.h MQTTClientPersistence.h MQTTProperties.h MQTTReasonCodes.h MQTTSubscribeOpts.h MQTTExportDeclarations.h
    DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

IF (PAHO_WITH_SSL)
    SET(OPENSSL_ROOT_DIR "" CACHE PATH "Directory containing OpenSSL libraries and includes")
    find_package(OpenSSL REQUIRED)

    IF (PAHO_BUILD_SHARED)
        ## common compilation for libpaho-mqtt3cs and libpaho-mqtt3as
    	## Note: SSL libraries must be recompiled due ifdefs
    	ADD_LIBRARY(common_ssl_obj OBJECT ${common_src})
    	TARGET_INCLUDE_DIRECTORIES(common_ssl_obj PUBLIC ${OPENSSL_INCLUDE_DIR})
    	SET_PROPERTY(TARGET common_ssl_obj PROPERTY	POSITION_INDEPENDENT_CODE ON)
    	SET_PROPERTY(TARGET common_ssl_obj PROPERTY COMPILE_DEFINITIONS "OPENSSL=1;PAHO_MQTT_EXPORTS=1")
    
        ADD_LIBRARY(paho-mqtt3cs SHARED $<TARGET_OBJECTS:common_ssl_obj> MQTTClient.c SSLSocket.c)
        ADD_LIBRARY(paho-mqtt3as SHARED $<TARGET_OBJECTS:common_ssl_obj> MQTTAsync.c MQTTAsyncUtils.c SSLSocket.c)
    
        SET_TARGET_PROPERTIES(
            paho-mqtt3cs paho-mqtt3as PROPERTIES
            VERSION ${CLIENT_VERSION}
            SOVERSION ${PAHO_VERSION_MAJOR}
            COMPILE_DEFINITIONS "OPENSSL=1;PAHO_MQTT_EXPORTS=1")

        IF(${CMAKE_SYSTEM_NAME} STREQUAL "Darwin")
		    SET(MQTTCLIENT_ENTRY_POINT _MQTTClient_init)
		    SET(MQTTASYNC_ENTRY_POINT _MQTTAsync_init)
        ELSEIF (NOT WIN32)
            SET(MQTTCLIENT_ENTRY_POINT MQTTClient_init)
		    SET(MQTTASYNC_ENTRY_POINT MQTTAsync_init)
        ENDIF()

        IF (NOT WIN32)
            SET_TARGET_PROPERTIES(
	           paho-mqtt3cs PROPERTIES
	           LINK_FLAGS "-Wl,-init,${MQTTCLIENT_ENTRY_POINT}")
	        SET_TARGET_PROPERTIES(
	           paho-mqtt3as PROPERTIES
	           LINK_FLAGS "-Wl,-init,${MQTTASYNC_ENTRY_POINT}")
        ENDIF()

        FOREACH(TARGET paho-mqtt3cs paho-mqtt3as)
            TARGET_INCLUDE_DIRECTORIES(${TARGET}
                PUBLIC
                    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
                    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
                PRIVATE
                    ${CMAKE_BINARY_DIR})
            TARGET_LINK_LIBRARIES(${TARGET}
                PUBLIC
                    OpenSSL::SSL OpenSSL::Crypto ${LIBS_SYSTEM})
        ENDFOREACH()
        INSTALL(TARGETS paho-mqtt3cs paho-mqtt3as
            EXPORT eclipse-paho-mqtt-cTargets
            ARCHIVE DESTINATION  ${CMAKE_INSTALL_LIBDIR}
            LIBRARY DESTINATION  ${CMAKE_INSTALL_LIBDIR}
            RUNTIME DESTINATION  ${CMAKE_INSTALL_BINDIR})
    ENDIF()

    IF (PAHO_BUILD_STATIC)
        ## common compilation for libpaho-mqtt3cs and libpaho-mqtt3as
    	## Note: SSL libraries must be recompiled due ifdefs
    	ADD_LIBRARY(common_ssl_obj_static OBJECT ${common_src})
    	TARGET_INCLUDE_DIRECTORIES(common_ssl_obj_static PUBLIC ${OPENSSL_INCLUDE_DIR})
    	SET_PROPERTY(TARGET common_ssl_obj_static PROPERTY POSITION_INDEPENDENT_CODE ON)
    	SET_PROPERTY(TARGET common_ssl_obj_static PROPERTY COMPILE_DEFINITIONS "OPENSSL=1;PAHO_MQTT_STATIC=1")
    
        ADD_LIBRARY(paho-mqtt3cs-static STATIC $<TARGET_OBJECTS:common_ssl_obj_static> MQTTClient.c SSLSocket.c)
        ADD_LIBRARY(paho-mqtt3as-static STATIC $<TARGET_OBJECTS:common_ssl_obj_static> MQTTAsync.c MQTTAsyncUtils.c SSLSocket.c)

        SET_TARGET_PROPERTIES(
            paho-mqtt3cs-static paho-mqtt3as-static PROPERTIES
            VERSION ${CLIENT_VERSION}
            SOVERSION ${PAHO_VERSION_MAJOR}
            COMPILE_DEFINITIONS "OPENSSL=1;PAHO_MQTT_STATIC=1")
        IF (NOT WIN32)
            SET_TARGET_PROPERTIES(paho-mqtt3cs-static PROPERTIES OUTPUT_NAME paho-mqtt3cs)
            SET_TARGET_PROPERTIES(paho-mqtt3as-static PROPERTIES OUTPUT_NAME paho-mqtt3as)
        ENDIF()

	    IF(${CMAKE_SYSTEM_NAME} STREQUAL "Darwin")
			SET(MQTTCLIENT_ENTRY_POINT _MQTTClient_init)
			SET(MQTTASYNC_ENTRY_POINT _MQTTAsync_init)
		ELSEIF (NOT WIN32)
			SET(MQTTCLIENT_ENTRY_POINT MQTTClient_init)
			SET(MQTTASYNC_ENTRY_POINT MQTTAsync_init)
		ENDIF()

		IF (NOT WIN32)
		    SET_TARGET_PROPERTIES(
	            paho-mqtt3cs-static PROPERTIES
	            LINK_FLAGS "-Wl,-init,${MQTTCLIENT_ENTRY_POINT}")
	        SET_TARGET_PROPERTIES(
	            paho-mqtt3as-static PROPERTIES
	            LINK_FLAGS "-Wl,-init,${MQTTASYNC_ENTRY_POINT}")
	    ENDIF()

        IF (NOT PAHO_BUILD_SHARED)
            INSTALL(TARGETS paho-mqtt3cs-static paho-mqtt3as-static
                EXPORT eclipse-paho-mqtt-cTargets
                ARCHIVE DESTINATION  ${CMAKE_INSTALL_LIBDIR}
                LIBRARY DESTINATION  ${CMAKE_INSTALL_LIBDIR}
                RUNTIME DESTINATION  ${CMAKE_INSTALL_BINDIR})
        ELSE()
            INSTALL(TARGETS paho-mqtt3cs-static paho-mqtt3as-static
                ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})
        ENDIF()
        FOREACH(TARGET paho-mqtt3cs-static paho-mqtt3as-static)
            TARGET_INCLUDE_DIRECTORIES(${TARGET}
                PUBLIC
                    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
                    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
                PRIVATE
                    ${CMAKE_BINARY_DIR})
            TARGET_LINK_LIBRARIES(${TARGET}
                PUBLIC
                    OpenSSL::SSL OpenSSL::Crypto ${LIBS_SYSTEM})
        ENDFOREACH()
    ENDIF()
ENDIF()

INSTALL(EXPORT eclipse-paho-mqtt-cTargets
    FILE eclipse-paho-mqtt-cConfig.cmake
    NAMESPACE eclipse-paho-mqtt-c::
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/eclipse-paho-mqtt-c)

INCLUDE(CMakePackageConfigHelpers)
WRITE_BASIC_PACKAGE_VERSION_FILE("eclipse-paho-mqtt-cConfigVersion.cmake"
    VERSION ${CLIENT_VERSION}
    COMPATIBILITY SameMajorVersion)
INSTALL(FILES
    "${CMAKE_CURRENT_BINARY_DIR}/eclipse-paho-mqtt-cConfigVersion.cmake"
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/eclipse-paho-mqtt-c)

=== test/CMakeLists.txt ===
PROJECT(mqtt-tests C)

SET(MQTT_TEST_BROKER "tcp://localhost:1883" CACHE STRING "Hostname of a test MQTT broker to use")
SET(MQTT_WS_TEST_BROKER "ws://localhost:1883" CACHE STRING "WebSocket connection to a test MQTT broker")
SET(MQTT_TEST_PROXY "tcp://localhost:1884" CACHE STRING "Hostname of the test proxy to use")
SET(MQTT_WS_TEST_PROXY "tcp://localhost:1884" CACHE STRING "WebSocket connection of a test proxy to use")
SET(MQTT_SSL_HOSTNAME "localhost" CACHE STRING "Hostname of a test SSL MQTT broker to use")

SET(CERTDIR ${CMAKE_SOURCE_DIR}/test/ssl)


IF (WIN32)
	SET(LIBS_SYSTEM ws2_32)
ELSEIF (UNIX)
	IF(CMAKE_SYSTEM_NAME MATCHES "Linux")
		SET(LIBS_SYSTEM c dl pthread)
	ELSEIF (CMAKE_SYSTEM_NAME MATCHES "FreeBSD")
		SET(LIBS_SYSTEM compat pthread)
	ELSE()
		SET(LIBS_SYSTEM c pthread)
	ENDIF()
ENDIF()

ADD_EXECUTABLE(
	thread
	thread.c ../src/Thread.c
)

SET_TARGET_PROPERTIES(
  thread PROPERTIES
  COMPILE_DEFINITIONS "NOSTACKTRACE;NOLOG_MESSAGES" 
)

TARGET_LINK_LIBRARIES(
	thread 
	${LIBS_SYSTEM}
)

IF (PAHO_BUILD_STATIC)
	ADD_EXECUTABLE(
		test1-static
		test1.c
	)
	TARGET_LINK_LIBRARIES(
		test1-static
		paho-mqtt3c-static
	)
	
	ADD_TEST(
		NAME test1-1-single-thread-client-static
		COMMAND "test1-static" "--test_no" "1" "--connection" ${MQTT_TEST_BROKER}
	)
	
	ADD_TEST(
		NAME test1-2-multithread-callbacks-static
		COMMAND "test1-static" "--test_no" "2" "--connection" ${MQTT_TEST_BROKER}
	)
	
	ADD_TEST(
		NAME test1-3-connack-return-codes-static
		COMMAND "test1-static" "--test_no" "3" "--connection" ${MQTT_TEST_BROKER}
	)
	
	ADD_TEST(
		NAME test1-4-client-persistence-static
		COMMAND "test1-static" "--test_no" "4" "--connection" ${MQTT_TEST_BROKER}
	)
	
	ADD_TEST(
		NAME test1-5-disconnect-with-quiesce-static
		COMMAND "test1-static" "--test_no" "5" "--connection" ${MQTT_TEST_BROKER}
	)
	
	ADD_TEST(
		NAME test1-6-connlost-will-message-static
		COMMAND "test1-static" "--test_no" "6" "--connection" ${MQTT_TEST_BROKER} "--proxy_connection" ${MQTT_TEST_PROXY}
	)
	
	ADD_TEST(
		NAME test1-7-connlost-binary-will-message-static
		COMMAND "test1-static" "--test_no" "7" "--connection" ${MQTT_TEST_BROKER} "--proxy_connection" ${MQTT_TEST_PROXY}
	)
	
	SET_TESTS_PROPERTIES(
		test1-1-single-thread-client-static
		test1-2-multithread-callbacks-static
		test1-3-connack-return-codes-static
		test1-4-client-persistence-static
		test1-5-disconnect-with-quiesce-static
		test1-6-connlost-will-message-static
		test1-7-connlost-binary-will-message-static
		PROPERTIES TIMEOUT 540
	)
ENDIF()

IF (PAHO_BUILD_SHARED)
	ADD_EXECUTABLE(
		test1
		test1.c
	)
	TARGET_LINK_LIBRARIES(
		test1
		paho-mqtt3c
	)
	
	IF (WIN32)
	ADD_CUSTOM_COMMAND(
		TARGET test1 PRE_BUILD
		COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_SOURCE_DIR}/dll-copy.cmake
		COMMENT "Copying DLLs to test directory"
	)
	ENDIF()
	
	ADD_TEST(
		NAME test1-1-single-thread-client
		COMMAND "test1" "--test_no" "1" "--connection" ${MQTT_TEST_BROKER}
	)
	
	ADD_TEST(
		NAME test1-2-multithread-callbacks
		COMMAND "test1" "--test_no" "2" "--connection" ${MQTT_TEST_BROKER}
	)
	
	ADD_TEST(
		NAME test1-3-connack-return-codes
		COMMAND "test1" "--test_no" "3" "--connection" ${MQTT_TEST_BROKER}
	)
	
	ADD_TEST(
		NAME test1-4-client-persistence
		COMMAND "test1" "--test_no" "4" "--connection" ${MQTT_TEST_BROKER}
	)
	
	ADD_TEST(
		NAME test1-5-disconnect-with-quiesce
		COMMAND "test1" "--test_no" "5" "--connection" ${MQTT_TEST_BROKER}
	)
	
	ADD_TEST(
		NAME test1-6-connlost-will-message
		COMMAND "test1" "--test_no" "6" "--connection" ${MQTT_TEST_BROKER} "--proxy_connection" ${MQTT_TEST_PROXY}
	)
	
	ADD_TEST(
		NAME test1-7-connlost-binary-will-message
		COMMAND "test1" "--test_no" "7" "--connection" ${MQTT_TEST_BROKER} "--proxy_connection" ${MQTT_TEST_PROXY}
	)
	
	SET_TESTS_PROPERTIES(
		test1-1-single-thread-client
		test1-2-multithread-callbacks
		test1-3-connack-return-codes
		test1-4-client-persistence
		test1-5-disconnect-with-quiesce
		test1-6-connlost-will-message
		test1-7-connlost-binary-will-message
		PROPERTIES TIMEOUT 540
	)
	
	ADD_TEST(
        NAME test1-1-ws-single-thread-client
        COMMAND "test1" "--test_no" "1" "--connection" ${MQTT_WS_TEST_BROKER}
    )
    
    ADD_TEST(
        NAME test1-2-ws-multithread-callbacks
        COMMAND "test1" "--test_no" "2" "--connection" ${MQTT_WS_TEST_BROKER}
    )
    
    ADD_TEST(
        NAME test1-3-ws-connack-return-codes
        COMMAND "test1" "--test_no" "3" "--connection" ${MQTT_WS_TEST_BROKER}
    )
    
    ADD_TEST(
        NAME test1-4-ws-client-persistence
        COMMAND "test1" "--test_no" "4" "--connection" ${MQTT_WS_TEST_BROKER}
    )
    
    ADD_TEST(
        NAME test1-5-ws-disconnect-with-quiesce
        COMMAND "test1" "--test_no" "5" "--connection" ${MQTT_WS_TEST_BROKER}
    )
    
    ADD_TEST(
        NAME test1-6-ws-connlost-will-message
        COMMAND "test1" "--test_no" "6" "--connection" ${MQTT_WS_TEST_BROKER} "--proxy_connection" ${MQTT_WS_TEST_PROXY}
    )
    
    ADD_TEST(
        NAME test1-7-ws-connlost-binary-will-message
        COMMAND "test1" "--test_no" "7" "--connection" ${MQTT_WS_TEST_BROKER} "--proxy_connection" ${MQTT_WS_TEST_PROXY}
    )
    
    SET_TESTS_PROPERTIES(
        test1-1-ws-single-thread-client
        test1-2-ws-multithread-callbacks
        test1-3-ws-connack-return-codes
        test1-4-ws-client-persistence
        test1-5-ws-disconnect-with-quiesce
        test1-6-ws-connlost-will-message
        test1-7-ws-connlost-binary-will-message
        PROPERTIES TIMEOUT 540
    )
ENDIF()



IF (PAHO_BUILD_STATIC)
	ADD_EXECUTABLE(
		test15-static
		test15.c
	)
	TARGET_LINK_LIBRARIES(
		test15-static
		paho-mqtt3c-static
	)
	
	ADD_TEST(
		NAME test15-1-single-thread-client-static
		COMMAND "test15-static" "--test_no" "1" "--connection" ${MQTT_TEST_BROKER} "--proxy_connection" ${MQTT_TEST_PROXY}
	)
	
	ADD_TEST(
		NAME test15-2-multithread-callbacks-static
		COMMAND "test15-static" "--test_no" "2" "--connection" ${MQTT_TEST_BROKER} "--proxy_connection" ${MQTT_TEST_PROXY}
	)
	
	ADD_TEST(
		NAME test15-3-connack-return-codes-static
		COMMAND "test15-static" "--test_no" "3" "--connection" ${MQTT_TEST_BROKER} "--proxy_connection" ${MQTT_TEST_PROXY}
	)
	
	ADD_TEST(
		NAME test15-4-client-persistence-static
		COMMAND "test15-static" "--test_no" "4" "--connection" ${MQTT_TEST_BROKER} "--proxy_connection" ${MQTT_TEST_PROXY}
	)
	
	ADD_TEST(
		NAME test15-5-disconnect-with-quiesce-static
		COMMAND "test15-static" "--test_no" "5" "--connection" ${MQTT_TEST_BROKER} "--proxy_connection" ${MQTT_TEST_PROXY}
	)
	
	ADD_TEST(
		NAME test15-6-connlost-will-message-static
		COMMAND "test15-static" "--test_no" "6" "--connection" ${MQTT_TEST_BROKER} "--proxy_connection" ${MQTT_TEST_PROXY}
	)
	
	ADD_TEST(
		NAME test15-7-connlost-binary-will-message-static
		COMMAND "test15-static" "--test_no" "7" "--connection" ${MQTT_TEST_BROKER} "--proxy_connection" ${MQTT_TEST_PROXY}
	)

	SET_TESTS_PROPERTIES(
		test15-1-single-thread-client-static
		test15-2-multithread-callbacks-static
		test15-3-connack-return-codes-static
		test15-4-client-persistence-static
		test15-5-disconnect-with-quiesce-static
		test15-6-connlost-will-message-static
		test15-7-connlost-binary-will-message-static
		PROPERTIES TIMEOUT 540
	)
ENDIF()

IF (PAHO_BUILD_SHARED)
	ADD_EXECUTABLE(
		test15
		test15.c
	)
	TARGET_LINK_LIBRARIES(
		test15
		paho-mqtt3c
	)

	ADD_TEST(
		NAME test15-1-single-thread-client
		COMMAND "test15" "--test_no" "1" "--connection" ${MQTT_TEST_BROKER} "--proxy_connection" ${MQTT_TEST_PROXY}
	)
	
	ADD_TEST(
		NAME test15-2-multithread-callbacks
		COMMAND "test15" "--test_no" "2" "--connection" ${MQTT_TEST_BROKER} "--proxy_connection" ${MQTT_TEST_PROXY}
	)
	
	ADD_TEST(
		NAME test15-3-connack-return-codes
		COMMAND "test15" "--test_no" "3" "--connection" ${MQTT_TEST_BROKER} "--proxy_connection" ${MQTT_TEST_PROXY}
	)
	
	ADD_TEST(
		NAME test15-4-client-persistence
		COMMAND "test15" "--test_no" "4" "--connection" ${MQTT_TEST_BROKER} "--proxy_connection" ${MQTT_TEST_PROXY}
	)
	
	ADD_TEST(
		NAME test15-5-disconnect-with-quiesce
		COMMAND "test15" "--test_no" "5" "--connection" ${MQTT_TEST_BROKER} "--proxy_connection" ${MQTT_TEST_PROXY}
	)
	
	ADD_TEST(
		NAME test15-6-connlost-will-message
		COMMAND "test15" "--test_no" "6" "--connection" ${MQTT_TEST_BROKER} "--proxy_connection" ${MQTT_TEST_PROXY}
	)
	
	ADD_TEST(
		NAME test15-7-connlost-binary-will-message
		COMMAND "test15" "--test_no" "7" "--connection" ${MQTT_TEST_BROKER} "--proxy_connection" ${MQTT_TEST_PROXY}
	)

	SET_TESTS_PROPERTIES(
		test15-1-single-thread-client
		test15-2-multithread-callbacks
		test15-3-connack-return-codes
		test15-4-client-persistence
		test15-5-disconnect-with-quiesce
		test15-6-connlost-will-message
		test15-7-connlost-binary-will-message
		PROPERTIES TIMEOUT 540
	)
	
	ADD_TEST(
        NAME test15-1-ws-single-thread-client
        COMMAND "test15" "--test_no" "1" "--connection" ${MQTT_WS_TEST_BROKER} "--proxy_connection" ${MQTT_WS_TEST_PROXY}
    )
    
    ADD_TEST(
        NAME test15-2-ws-multithread-callbacks
        COMMAND "test15" "--test_no" "2" "--connection" ${MQTT_WS_TEST_BROKER} "--proxy_connection" ${MQTT_WS_TEST_PROXY}
    )
    
    ADD_TEST(
        NAME test15-3-ws-connack-return-codes
        COMMAND "test15" "--test_no" "3" "--connection" ${MQTT_WS_TEST_BROKER} "--proxy_connection" ${MQTT_WS_TEST_PROXY}
    )
    
    ADD_TEST(
        NAME test15-4-ws-client-persistence
        COMMAND "test15" "--test_no" "4" "--connection" ${MQTT_WS_TEST_BROKER} "--proxy_connection" ${MQTT_WS_TEST_PROXY}
    )
    
    ADD_TEST(
        NAME test15-5-ws-disconnect-with-quiesce
        COMMAND "test15" "--test_no" "5" "--connection" ${MQTT_WS_TEST_BROKER} "--proxy_connection" ${MQTT_WS_TEST_PROXY}
    )
    
    ADD_TEST(
        NAME test15-6-ws-connlost-will-message
        COMMAND "test15" "--test_no" "6" "--connection" ${MQTT_WS_TEST_BROKER} "--proxy_connection" ${MQTT_WS_TEST_PROXY}
    )
    
    ADD_TEST(
        NAME test15-7-ws-connlost-binary-will-message
        COMMAND "test15" "--test_no" "7" "--connection" ${MQTT_WS_TEST_BROKER} "--proxy_connection" ${MQTT_WS_TEST_PROXY}
    )

    SET_TESTS_PROPERTIES(
        test15-1-ws-single-thread-client
        test15-2-ws-multithread-callbacks
        test15-3-ws-connack-return-codes
        test15-4-ws-client-persistence
        test15-5-ws-disconnect-with-quiesce
        test15-6-ws-connlost-will-message
        test15-7-ws-connlost-binary-will-message
        PROPERTIES TIMEOUT 540
    )
ENDIF()

IF (PAHO_BUILD_STATIC)
	ADD_EXECUTABLE(
		test2-static
		test2.c
	)
	
	TARGET_LINK_LIBRARIES(
		test2-static
		paho-mqtt3c-static
	)
	
	ADD_TEST(
		NAME test2-1-multiple-threads-single-client-static
		COMMAND test2-static "--connection" ${MQTT_TEST_BROKER}
	)
	
	SET_TESTS_PROPERTIES(
		test2-1-multiple-threads-single-client-static
		PROPERTIES TIMEOUT 540
	)
ENDIF()

IF (PAHO_BUILD_SHARED)
	ADD_EXECUTABLE(
		test2
		test2.c
	)
	
	TARGET_LINK_LIBRARIES(
		test2
		paho-mqtt3c
	)
	
	ADD_TEST(
        NAME test2-1-multiple-threads-single-client
        COMMAND test2 "--connection" ${MQTT_TEST_BROKER}
    )

	ADD_TEST(
		NAME test2-1-ws-multiple-threads-single-client
		COMMAND test2 "--connection" ${MQTT_WS_TEST_BROKER}
	)
	
	SET_TESTS_PROPERTIES(
	    test2-1-multiple-threads-single-client
		test2-1-ws-multiple-threads-single-client
		PROPERTIES TIMEOUT 540
	)
ENDIF()


IF (PAHO_WITH_SSL)

	IF (PAHO_BUILD_STATIC)
		ADD_EXECUTABLE(
			test3-static
			test3.c
		)
		TARGET_LINK_LIBRARIES(
			test3-static
			paho-mqtt3cs-static
		)
		
		ADD_TEST(
			NAME test3-1-ssl-conn-to-non-SSL-broker-static
			COMMAND test3-static "--test_no" "1" "--hostname" ${MQTT_SSL_HOSTNAME} "--client_key"	"${CERTDIR}/client.pem" "--server_key"	"${CERTDIR}/test-root-ca.crt"
		)
		
		ADD_TEST(
			NAME test3-2as-mutual-ssl-auth-single-thread-static

=== debian/changelog ===
paho.mqtt.c (1.3.12-1) unstable; urgency=medium

  [ Vagrant Cascadian ]
  * debian/rules: Pass -DCMAKE_BUILD_RPATH_USE_ORIGIN=ON via dh_auto_configure
    override. (Closes: #1003803)

  [ Roman Ondráček ]
  * New upstream version 1.3.12 (Closes: #1023862)
  * debian/control: update Standards-Version to 4.6.2.0
  * debian/symbols: fix Build-Depends-Package
  * Release version 1.3.12-1

 -- Roman Ondráček <mail@romanondracek.cz>  Tue, 28 Feb 2023 23:09:12 +0100

=== debian/control ===
Source: paho.mqtt.c
Priority: optional
Maintainer: Roman Ondráček <mail@romanondracek.cz>
Build-Depends: debhelper (>= 12), debhelper-compat (= 13), cmake (>= 2.8.12), libssl-dev
Rules-Requires-Root: no
Standards-Version: 4.6.2.0
Section: libs
Homepage: https://github.com/eclipse/paho.mqtt.c/
Vcs-Browser: https://gitlab.iqrf.org/open-source/iqrf-gateway-daemon-utils/paho.mqtt.c
Vcs-Git: https://gitlab.iqrf.org/open-source/iqrf-gateway-daemon-utils/paho.mqtt.c.git

Package: libpaho-mqtt-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libpaho-mqtt1.3 (= ${binary:Version}), ${misc:Depends}
Description: Eclipse Paho MQTT C client - development files
 This libraries enable applications to connect to an MQTT broker to publish
 messages, and to subscribe to topics and receive published messages.
 .
 This package contains files for development and static libraries.

Package: libpaho-mqtt1.3
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Eclipse Paho MQTT C client - shared libraries
 This libraries enable applications to connect to an MQTT broker to publish
 messages, and to subscribe to topics and receive published messages.

Package: paho.mqtt.c-examples
Section: misc
Architecture: any
Depends: libpaho-mqtt1.3 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Eclipse Paho MQTT C client - example files
 This libraries enable applications to connect to an MQTT broker to publish
 messages, and to subscribe to topics and receive published messages.
 .
 This package contains example files and demonstration programs.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@  --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- -DPAHO_WITH_SSL=TRUE -DPAHO_ENABLE_TESTING=FALSE \
	-DPAHO_BUILD_STATIC=TRUE -DPAHO_BUILD_SAMPLES=TRUE -DCMAKE_BUILD_RPATH_USE_ORIGIN=ON

override_dh_auto_install:
	dh_auto_install

## paho.mqtt.c 1.3.13

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #*******************************************************************************
-#  Copyright (c) 2015, 2020 logi.cals GmbH and others
+#  Copyright (c) 2015, 2023 logi.cals GmbH and others
 #
 #  All rights reserved. This program and the accompanying materials
 #  are made available under the terms of the Eclipse Public License v2.0
@@ -44,6 +44,7 @@
 
 ## build options
 SET(PAHO_WITH_SSL FALSE CACHE BOOL "Flag that defines whether to build ssl-enabled binaries too. ")
+SET(PAHO_WITH_LIBUUID FALSE CACHE BOOL "Flag that defines whether libuuid or a custom uuid implementation should be used")
 SET(PAHO_BUILD_SHARED TRUE CACHE BOOL "Build shared library")
 SET(PAHO_BUILD_STATIC FALSE CACHE BOOL "Build static library")
 SET(PAHO_BUILD_DOCUMENTATION FALSE CACHE BOOL "Create and install the HTML based API documentation (requires Doxygen)")
@@ -62,8 +63,16 @@
   ADD_DEFINITIONS(-DUSE_SELECT=1)
 ENDIF()
 
+IF (PAHO_WITH_LIBUUID)
+  ADD_DEFINITIONS(-DUSE_LIBUUID=1)
+ENDIF()
+
 IF (NOT PAHO_BUILD_SHARED AND NOT PAHO_BUILD_STATIC)
     MESSAGE(FATAL_ERROR "You must set either PAHO_BUILD_SHARED, PAHO_BUILD_STATIC, or both")
+ENDIF()
+
+IF (PAHO_BUILD_SAMPLES AND NOT PAHO_WITH_SSL)
+    MESSAGE(FATAL_ERROR "You must build with SSL to build the samples")
 ENDIF()
 
 IF(PAHO_BUILD_DEB_PACKAGE)

=== doc/CMakeLists.txt ===
#*******************************************************************************
#  Copyright (c) 2015 logi.cals GmbH
# 
#  All rights reserved. This program and the accompanying materials
#  are made available under the terms of the Eclipse Public License v2.0
#  and Eclipse Distribution License v1.0 which accompany this distribution. 
# 
#  The Eclipse Public License is available at 
#     https://www.eclipse.org/legal/epl-2.0/
#  and the Eclipse Distribution License is available at 
#    http://www.eclipse.org/org/documents/edl-v10.php.
# 
#  Contributors:
#     Rainer Poisel - initial version
#*******************************************************************************/

# Note: on OS X you should install XCode and the associated command-line tools

### documentation settings
FIND_PACKAGE(Doxygen)
IF(NOT DOXYGEN_FOUND)
    message(FATAL_ERROR "Doxygen is needed to build the documentation.")
ENDIF()
SET(DOXYTARGETS)
FILE(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/doc)
FOREACH(DOXYFILE_SRC DoxyfileV3ClientAPI;DoxyfileV3AsyncAPI;DoxyfileV3ClientInternal)
    SET(DOXYFILE_IN ${DOXYFILE_SRC}.in)
    SET(DOXYFILE ${CMAKE_CURRENT_BINARY_DIR}/${DOXYFILE_SRC})

    CONFIGURE_FILE(${DOXYFILE_IN} ${DOXYFILE} @ONLY)
    ADD_CUSTOM_TARGET(${DOXYFILE_SRC}.target
        COMMAND ${DOXYGEN_EXECUTABLE} ${DOXYFILE}
            WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
            COMMENT "Generating API documentation with Doxygen"
            VERBATIM
    )
    SET(DOXYTARGETS ${DOXYTARGETS} ${DOXYFILE_SRC}.target)
ENDFOREACH(DOXYFILE_SRC)

ADD_CUSTOM_TARGET(doc ALL DEPENDS ${DOXYTARGETS})
IF (PAHO_ENABLE_CPACK)
    INSTALL(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/doc/ DESTINATION ${CMAKE_INSTALL_DOCDIR})
ELSE()
    INSTALL(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/doc DESTINATION ${CMAKE_INSTALL_DOCDIR})
ENDIF()

=== src/samples/CMakeLists.txt ===
#*******************************************************************************
#  Copyright (c) 2015, 2020 logi.cals GmbH and others
#
#  All rights reserved. This program and the accompanying materials
#  are made available under the terms of the Eclipse Public License v2.0
#  and Eclipse Distribution License v1.0 which accompany this distribution.
#
#  The Eclipse Public License is available at
#     https://www.eclipse.org/legal/epl-2.0/
#  and the Eclipse Distribution License is available at
#    http://www.eclipse.org/org/documents/edl-v10.php.
#
#  Contributors:
#     Rainer Poisel - initial version
#     Ian Craggs - update sample names
#*******************************************************************************/

# Note: on OS X you should install XCode and the associated command-line tools

## compilation/linkage settings
INCLUDE_DIRECTORIES(
    .
    ${PROJECT_SOURCE_DIR}/src
    ${PROJECT_BINARY_DIR}
    )

IF (WIN32)
  	ADD_DEFINITIONS(/DCMAKE_BUILD /D_CRT_SECURE_NO_DEPRECATE)
ENDIF()

# sample files c

IF (PAHO_BUILD_SHARED)
ADD_EXECUTABLE(paho_c_pub paho_c_pub.c pubsub_opts.c)
ADD_EXECUTABLE(paho_c_sub paho_c_sub.c pubsub_opts.c)
ADD_EXECUTABLE(paho_cs_pub paho_cs_pub.c pubsub_opts.c)
ADD_EXECUTABLE(paho_cs_sub paho_cs_sub.c pubsub_opts.c)

SET_TARGET_PROPERTIES(
     paho_c_pub paho_c_sub paho_cs_pub paho_cs_sub PROPERTIES
     COMPILE_DEFINITIONS "PAHO_MQTT_IMPORTS=1")

TARGET_LINK_LIBRARIES(paho_c_pub paho-mqtt3as)
TARGET_LINK_LIBRARIES(paho_c_sub paho-mqtt3as)
TARGET_LINK_LIBRARIES(paho_cs_pub paho-mqtt3cs)
TARGET_LINK_LIBRARIES(paho_cs_sub paho-mqtt3cs)

ADD_EXECUTABLE(MQTTAsync_subscribe MQTTAsync_subscribe.c)
ADD_EXECUTABLE(MQTTAsync_publish MQTTAsync_publish.c)
ADD_EXECUTABLE(MQTTAsync_publish_time MQTTAsync_publish_time.c)
ADD_EXECUTABLE(MQTTClient_subscribe MQTTClient_subscribe.c)
ADD_EXECUTABLE(MQTTClient_publish MQTTClient_publish.c)
ADD_EXECUTABLE(MQTTClient_publish_async MQTTClient_publish_async.c)

SET_TARGET_PROPERTIES(
     MQTTAsync_subscribe MQTTAsync_publish MQTTAsync_publish_time MQTTClient_subscribe MQTTClient_publish MQTTClient_publish_async PROPERTIES
     COMPILE_DEFINITIONS "PAHO_MQTT_IMPORTS=1")

TARGET_LINK_LIBRARIES(MQTTAsync_subscribe paho-mqtt3a)
TARGET_LINK_LIBRARIES(MQTTAsync_publish paho-mqtt3a)
TARGET_LINK_LIBRARIES(MQTTAsync_publish_time paho-mqtt3a)
TARGET_LINK_LIBRARIES(MQTTClient_subscribe paho-mqtt3c)
TARGET_LINK_LIBRARIES(MQTTClient_publish paho-mqtt3c)
TARGET_LINK_LIBRARIES(MQTTClient_publish_async paho-mqtt3c)

INSTALL(TARGETS paho_c_sub
                paho_c_pub
                paho_cs_sub
                paho_cs_pub
                MQTTAsync_subscribe
	              MQTTAsync_publish
	              MQTTAsync_publish_time
                MQTTClient_subscribe
                MQTTClient_publish
                MQTTClient_publish_async

    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})
ENDIF()

IF (PAHO_BUILD_STATIC)
ADD_EXECUTABLE(paho_c_pub_static paho_c_pub.c pubsub_opts.c)
ADD_EXECUTABLE(paho_c_sub_static paho_c_sub.c pubsub_opts.c)
ADD_EXECUTABLE(paho_cs_pub_static paho_cs_pub.c pubsub_opts.c)
ADD_EXECUTABLE(paho_cs_sub_static paho_cs_sub.c pubsub_opts.c)

TARGET_LINK_LIBRARIES(paho_c_pub_static paho-mqtt3as-static)
TARGET_LINK_LIBRARIES(paho_c_sub_static paho-mqtt3as-static)
TARGET_LINK_LIBRARIES(paho_cs_pub_static paho-mqtt3cs-static)
TARGET_LINK_LIBRARIES(paho_cs_sub_static paho-mqtt3cs-static)

INSTALL(TARGETS paho_c_sub_static
                paho_c_pub_static
                paho_cs_sub_static
                paho_cs_pub_static

    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})
ENDIF()

=== debian/changelog ===
paho.mqtt.c (1.3.13-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:13:28 +1100

paho.mqtt.c (1.3.13-1build1) noble; urgency=medium

  * No-change rebuild against libssl3t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 04 Mar 2024 20:33:24 +0000

paho.mqtt.c (1.3.13-1) unstable; urgency=medium

  * New upstream version 1.3.13
  * Fix format of man pages

 -- Roman Ondráček <mail@romanondracek.cz>  Sat, 04 Nov 2023 19:30:00 +0100

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,14 @@
 Source: paho.mqtt.c
 Priority: optional
-Maintainer: Roman Ondráček <mail@romanondracek.cz>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Roman Ondráček <mail@romanondracek.cz>
 Build-Depends: debhelper (>= 12), debhelper-compat (= 13), cmake (>= 2.8.12), libssl-dev
 Rules-Requires-Root: no
 Standards-Version: 4.6.2.0
 Section: libs
 Homepage: https://github.com/eclipse/paho.mqtt.c/
-Vcs-Browser: https://gitlab.iqrf.org/open-source/iqrf-gateway-daemon-utils/paho.mqtt.c
-Vcs-Git: https://gitlab.iqrf.org/open-source/iqrf-gateway-daemon-utils/paho.mqtt.c.git
+Vcs-Browser: https://salsa.debian.org/ondracek/paho.mqtt.c
+Vcs-Git: https://salsa.debian.org/ondracek/paho.mqtt.c.git
 
 Package: libpaho-mqtt-dev
 Section: libdevel
